#define _SVID_SOURCE
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define SHMSZ 1024

int main() {
	char c;
	int shmid;
	key_t key = 56789;
	char *shm, *s;
	if ((shmid = shmget(key, SHMSZ, IPC_CREAT | 0777)) < 0) {
		perror("shmget");
		exit(1);
	}
	if ((shm = shmat(shmid, NULL, 0)) == (char*)-1) {
		perror("shmat");
		exit(1);
	}
	s = shm;
	for (c = 'a'; c <= 'z'; c++) *s++ = c;
	*s = '\0';

//	Finally, we wait until the other process changes the first character of
//	our memory to '*', indicating that it has read what we put there.

	while (*shm != '*') sleep(1);
//	shmctl(shmid, IPC_RMID, 0);
	return 0;
}

