#define _XOPEN_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#define KEY 75
#define K 1024
int ident_segm;
void rem(int);

int main() {
	for (int i = 0; i < 20; i++) signal(i, rem);
	ident_segm = shmget(KEY, K, 0777 | IPC_CREAT);
	void* addr = shmat (ident_segm, 0, 0);
	printf ("\naddress = %p\n", addr);
	int *wsk = (int*)addr;
	srand48(time(0));
	for (int i = 0; i < 8; i++) wsk[i] = lrand48() % 1000;
	if (fork() == 0) execl ("shmem1", "shmem1", 0);
	for (int i = 0; i < 8; i++) printf ("parent: m[%d] = %5d\n", i, wsk[i]);
	pause();	//	wait for a signal
	return 0;
}

void rem(int i) {
	printf ("\nCalling rem, int = %d\n\n", i);
	shmctl(ident_segm, IPC_RMID, 0);
	exit(0);
}

